clear, clc, mode(0), close(winsid()), getd()

/// Kalmanův filtr pro filtraci šumu z naměřených dat -- elipsoid

//// Simulace
tt=0:.1:(2*%pi);
nd=length(tt);
sd=2;                              
e=[sd*rand(1,nd,'n'); sd*rand(1,nd,'n')]; //šum
g=[10*cos(tt); 15*sin(tt)];        // čistý signál
y=g+e;                             // naměřený signál s šumem





////Kalmanův filtr pro filtraci šumu
Rx=1e6*eye(2,2);                   // počáteční kovarianční matice stavu
Rw=.01*eye(2,2);                   // kovarianční matice vývoje stavu
Rv=0.1*eye(2,2);                    // kovarianční matice měření výstupu
M=[1 0;                             // parametry
   0 1];
A=[1 0;
   0 1];
N=[0 0]';                          
B=0;
x(:,1)=[0 0]';                      // počáteční střední hodnota stavu
 
for t=2:nd
  [x(:,t),Rx,yp]=Kalman(x(:,t-1),y(:,t),0,M,N,A,B,Rw,Rv,Rx);
end



// Výsledky

plot(g(1,:),g(2,:),'k')
plot(y(1,:),y(2,:),'b.')
plot(x(1,:),x(2,:),'r.:')
legend('signál','naměřený signál','odhad');
title('Kalmanův filtr - filtrace šumu','fontsize',6)
ylabel('Data','fontsize',5)
xlabel('Data','fontsize',5)
